# mini/plugs/list.py
#
#

## IMPORTS


from mini.utils import error, time_string, to_time, time_stamp, do_objects, format_obj, short_date
from mini import kernel

## BASIC IMPORTS

import threading
import logging
import re

## find command 

def do_find(event):
    args = event.args
    opts = event.opts
    knobs = event.knobs
    if "mdate" not in args: args.insert(0, "mdate")
    else: args.extend(list(opts.keys()))
    done = []
    objs = []
    for obj in do_objects(event):
        try:
            obj.mdate = short_date(obj.Date)
            if not obj.mdate: obj.mdate = to_time(obj.added)
        except: error()
        value = None
        go = True
        for arg in args:
            try: value = getattr(obj, arg)
            except AttributeError: continue
            if not value: continue
        if go: objs.append(obj)
    for obj in sorted(objs, key=lambda x: x.mdate):
        txt = ""
        for arg in args:
            try: txt += "%s -=- " % obj[arg]
            except KeyError: continue
        if not txt: continue
        txt = txt[:-5]
        event.reply(txt)

kernel.register("find", do_find)
