# mini/plugs/directory.py
#
#

""" mail input plugin. """

## IMPORTS

from mini.utils import strip_html, j, error, need_skip
from mini import kernel, Object

import email.message
import datetime
import logging
import email
import time
import os

def scan_dir(*args, **kwargs):
    target = args[0] 
    teller = 0
    for fn in os.listdir(target):
        if fn.startswith("."): continue
        ff = target + os.sep + fn 
        logging.warn("reading %s" % ff)
        if os.path.isdir(ff): scan_dir(ff) ; continue
        o = Object()
        try:
            try: data = open(ff, "r").read()
            except Exception as ex: logging.warn("problem scanning %s - %s" % (ff, str(ex))) ; continue 
            message = email.message_from_string(data) ; o.update(message.items())
            o.text = ""
            o.filename = ff
            payload = message.get_payload()
            go = True
            for load in payload:
                if not load: continue
                if need_skip(load, [], ["text/plain", ],): go = False ; break
                else: o.text += str(load)
            if not go: continue
        except IsADirectoryError: continue
        except Exception: error() ; continue
        o.save()
        teller += 1
        logging.warn("at %s" % teller)

## COMMANDS

def do_scan(event):
    if not os.path.isdir(event.rest): logging.warn("scan <directory>") ; return
    scan_dir(event.rest)
    event.reply("done")

kernel.register("scan", do_scan)
